%% (c) Gertjan van Noord, 2012

:- multifile macro/2.

%%%

macro(sentence, [ [dict,spatie]*, dict] ).

macro(dict, {iso,pph}).

macro(iso,file('iso.m')).  % generic dictionary
macro(pph,file('pph.m')).  % task specific dictionary

macro(spatie, ' ').

macro(lev1,{subs, del, ins}).

macro(letter, a .. z ).

%% we only allow ins/subs/del with small case letters and space

macro(subs,[? *, {spatie,letter} : {spatie,letter}, ? *]).

macro(del,[? *, {spatie,letter} : [], ? *]).

macro(ins,[? *, [] : {spatie,letter}, ? *]).

macro(confusable_t,      lev1 o sentence).
macro(confusable_tt,     lev1 o lev1 o sentence).
macro(confusable_ttt,    lev1 o lev1 o lev1 o sentence).
macro(confusable_tttt,   lev1 o lev1 o lev1 o lev1 o sentence).
macro(confusable_ttttt,  lev1 o lev1 o lev1 o lev1 o lev1 o sentence).
macro(confusable_tttttt, lev1 o lev1 o lev1 o lev1 o lev1 o lev1 o sentence).

%% rather than applying the transducer to the given input,
%% it is often better to construct the composition of the
%% input and the transducer, and then generate strings from
%% the resulting (determinized) recognizer
%%
%% this is so, because the transducer is one-to-(very)many

macro(apply_confusables(E), determinize(range(E o confusable_ttt))).

%% this is essentially what is done in confusables.pl

%% awk -F\| '{ print $2 }' /net/aistaff/vannoord/z/Alpino/Suites/PPHfull.named_sents | tr ' ' '\012' | sort | uniq > pph.dict
%% fsa write=fast -dict2m iso.dict > iso.m
%% fsa write=fast -dict2m pph.dict > pph.m
%% fsa read=fast write=fast -aux conf -r confusable_t > confusable_t.t
%% fsa read=fast write=fast -aux conf -r confusable_tt > confusable_tt.t
%% fsa read=fast write=fast -aux conf -r confusable_ttt > confusable_ttt.t
%% fsa read=fast write=fast -aux conf -r confusable_tttt > confusable_tttt.t
%% fsa read=fast write=fast -aux conf -r confusable_ttttt > confusable_ttttt.t
%% fsa read=fast write=fast -aux conf -r confusable_tttttt > confusable_tttttt.t

%% cat /net/aistaff/vannoord/z/Alpino/Suites/PPHfull.named_sents |\
%%   sicstus -l confusables